<?php
/*
 * Copyright (c) 2013, webvariants GbR, http://www.webvariants.de
 *
 * This file is released under the terms of the MIT license. You can find the
 * complete text in the attached LICENSE file or online at:
 *
 * http://www.opensource.org/licenses/mit-license.php
 */

define('_WV8_PATH', __DIR__.'/');

$loader     = $container->getClassLoader();
$dispatcher = $container->getDispatcher();

// make sure this load path is known
$loader->add('', _WV8_PATH.'lib');

// extend container
$container['wv8-manager'] = $container->share(function($c) {
	$config   = $c->getConfig();
	$registry = $c['sly-registry-persistent'];
	$syncer   = $c['wv8-synchronizer'];
	$files    = $c['sly-service-json'];
	$manager  = new WV8_Settings_Manager($config, $syncer, $registry, $files);

	if ($c->getEnvironment() !== 'prod') {
		$manager->refresh();
	}

	return $manager;
});

$container['wv8-synchronizer'] = $container->share(function($c) {
	return new WV8_Settings_Synchronizer($c->getConfig(), $c->getPersistence(), $c['sly-service-language']);
});

$container['wv8-provider'] = $container->share(function($c) {
	return new WV8_Settings_Provider($c['wv8-manager']);
});

$container['wv8-listeners'] = $container->share(function($c) {
	return new WV8_Listeners($c);
});

// load language file
if ($container['sly-app']->isBackend()) {
	$container['sly-i18n']->appendFile(_WV8_PATH.'lang');
}

// register event listeners
$dispatcher->addListener('SLY_CACHE_CLEARED',           array('%wv8-listeners%', 'onClearCache'));
$dispatcher->addListener('SLY_SYSTEM_CACHES',           array('%wv8-listeners%', 'onSystemCacheList'));
$dispatcher->addListener('SLY_MEDIA_USAGES',            array('%wv8-listeners%', 'onMediaUsages'));
$dispatcher->addListener('SLY_BACKEND_NAVIGATION_INIT', array('%wv8-listeners%', 'onBackendNavigation'));
$dispatcher->addListener('SLY_DB_IMPORTER_AFTER',       array('%wv8-listeners%', 'onDatabaseImport'));
